Merged revisions 115285 via svnmerge from
[asterisk/asterisk.git] / contrib / init.d / rc.debian.asterisk
1 #! /bin/sh
2 # $Id$
3 #
4 # Mon Jun 04 2007 IƱaki Baz Castillo <ibc@in.ilimit.es>
5 # - Eliminated SAFE_ASTERISK since it doesn't work as LSB script (it could require a independent "safe_asterisk" init script).
6 # - Load and use the standar "/lib/lsb/init-functions".
7 # - Addded "--oknodo" to "start-stop-daemon" for compatibility with LSB:
8 #   http://www.linux-foundation.org/spec/refspecs/LSB_3.0.0/LSB-Core-generic/LSB-Core-generic/iniscrptact.html
9 #
10 # Thu Nov 17 2005 Gregory Boehnlein <damin@nacs.net>
11 # - Reversed behavior of LD_ASSUME_KERNEL=2.4.1
12 # - Added detailed failure messages
13 #
14 # Sun Jul 18 2004 Gregory Boehnlein <damin@nacs.net>
15 # - Added test for safe_asterisk
16 # - Changed "stop gracefully" to "stop now"
17 # - Added support for -U and -G command line options
18 # - Modified "reload" to call asterisk -rx 'reload' 
19
20 PATH=/usr/local/sbin:/usr/local/bin:/sbin:/bin:/usr/sbin:/usr/bin
21 NAME=asterisk
22 DESC="Asterisk PBX"
23 # Full path to asterisk binary
24 DAEMON=/usr/sbin/asterisk
25
26 # Uncomment this ONLY if you know what you are doing.
27 # export LD_ASSUME_KERNEL=2.4.1
28
29 # Uncomment the following and set them to the user/groups that you
30 # want to run Asterisk as. NOTE: this requires substantial work to
31 # be sure that Asterisk's environment has permission to write the
32 # files required  for  its  operation, including logs, its comm
33 # socket, the asterisk database, etc.
34 #AST_USER="asterisk"
35 #AST_GROUP="asterisk"
36
37 set -e
38
39 if ! [ -x $DAEMON ] ; then
40         echo "ERROR: $DAEMON not found"
41         exit 0
42 fi
43
44 if ! [ -d /etc/asterisk ] ; then
45         echo "ERROR: /etc/asterisk directory not found"
46         exit 0
47 fi
48
49 # Use the LSB standar functions for services management
50 . /lib/lsb/init-functions
51
52 case "$1" in
53   start)
54         # Check if Asterisk is already running.  If it is, then bug out, because
55         # starting up Asterisk when Asterisk is already running is very bad.
56         VERSION=`${ASTSBINDIR}/asterisk -rx 'core show version'`
57         if [ "${VERSION:0:8}" = "Asterisk" ]; then # otherwise "Unable t"
58                 echo "Asterisk is already running.  $0 will exit now."
59                 exit 1
60         fi
61
62         log_begin_msg "Starting $DESC: $NAME"
63         if [ $AST_USER ] ; then
64                 ASTARGS="-U $AST_USER"
65         fi
66         if [ $AST_GROUP ] ; then
67                 ASTARGS="$ASTARGS -G $AST_GROUP"
68         fi
69         # "start-stop-daemon --oknodo" returns 0 even if Asterisk was already running (as LSB expects):
70         start-stop-daemon --start --oknodo --exec $DAEMON -- $ASTARGS
71         log_end_msg $?
72         ;;
73   stop)
74         log_begin_msg "Stopping $DESC: $NAME"
75         # "start-stop-daemon --oknodo" returns 0 even if Asterisk was already stopped (as LSB expects):
76         start-stop-daemon --stop --oknodo --exec $DAEMON
77         log_end_msg $?
78         ;;
79   reload)
80         echo "Reloading $DESC configuration files."
81         $DAEMON -rx 'reload' > /dev/null 2> /dev/null
82         ;;
83   restart|force-reload)
84         $0 stop
85         sleep 2  # It needs some time to really be stopped.
86         $0 start
87         # "restart|force-reload" starts Asterisk and returns 0 even if Asterisk was stopped (as LSB expects).
88         ;;
89   *)
90         N=/etc/init.d/$NAME
91         echo "Usage: $N {start|stop|restart|reload|force-reload}" >&2
92         exit 1
93         ;;
94 esac